"""
Some (initially private) typing helpers for bsonschema's types.
"""
from typing import Any, Callable, Iterable, Protocol, Tuple, Union

import referencing.bsonschema

from bsonschema.protocols import Validator


class SchemaKeywordValidator(Protocol):
    def __call__(
        self,
        validator: Validator,
        value: Any,
        instance: Any,
        schema: referencing.bsonschema.Schema,
    ) -> None:
        ...


id_of = Callable[[referencing.bsonschema.Schema], Union[str, None]]


ApplicableValidators = Callable[
    [referencing.bsonschema.Schema],
    Iterable[Tuple[str, Any]],
]
